package com.taais.biz.listener;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.taais.common.core.exception.ServiceException;
import com.taais.common.core.utils.SpringUtils;
import com.taais.common.core.utils.ValidatorUtils;
import com.taais.common.excel.core.ExcelListener;
import com.taais.common.excel.core.ExcelResult;
import com.taais.biz.domain.bo.TrackSequenceBo;
import com.taais.biz.domain.vo.TrackSequenceImportVo;
import com.taais.biz.domain.vo.TrackSequenceVo;
import com.taais.biz.service.ITrackSequenceService;
import lombok.extern.slf4j.Slf4j;

import java.util.List;

/**
 * 注视轨迹序列自定义导入
 *
 * @author wangkang
 */
@Slf4j
public class TrackSequenceImportListener extends AnalysisEventListener<TrackSequenceImportVo> implements ExcelListener<TrackSequenceImportVo> {
    private final ITrackSequenceService trackSequenceService;

    private final Boolean isUpdateSupport;
    private int successNum = 0;
    private int failureNum = 0;
    private final StringBuilder successMsg = new StringBuilder();
    private final StringBuilder failureMsg = new StringBuilder();

    public TrackSequenceImportListener(Boolean isUpdateSupport) {
        this.trackSequenceService = SpringUtils.getBean(ITrackSequenceService.class);
        this.isUpdateSupport = isUpdateSupport;
    }

    @Override
    public void invoke(TrackSequenceImportVo trackSequenceVo, AnalysisContext context) {
        try {

            TrackSequenceBo trackSequenceBo = BeanUtil.toBean(trackSequenceVo, TrackSequenceBo.class);

            //TODO:根据某个字段，查询数据库表中是否存在记录，不存在就新增，存在就更新
            TrackSequenceVo trackSequenceVo1 = null;

            //trackSequenceVo1 = trackSequenceService.selectBySomefield(trackSequenceVo.getSomefield());
            if (ObjectUtil.isNull(trackSequenceVo1)) {
                //不存在就新增
                trackSequenceBo.setVersion(0);
                ValidatorUtils.validate(trackSequenceBo);
                boolean inserted = trackSequenceService.insert(trackSequenceBo);

                if (inserted) {
                    successNum++;
                    successMsg.append("<br/>").append(successNum).append("、注视轨迹序列 记录导入成功");
                    return;
                } else {
                    failureNum++;
                    failureMsg.append("<br/>").append(failureNum).append("、注视轨迹序列 记录导入失败");
                    return;
                }
            } else if (isUpdateSupport) {
                //存在就更新
                trackSequenceBo.setId(trackSequenceVo1.getId());//主键
                trackSequenceBo.setVersion(trackSequenceVo1.getVersion());
                boolean updated = trackSequenceService.update(trackSequenceBo);
                if (updated) {
                    successNum++;
                    successMsg.append("<br/>").append(successNum).append("、注视轨迹序列 记录更新成功");
                    return;
                } else {
                    failureNum++;
                    failureMsg.append("<br/>").append(failureNum).append("、注视轨迹序列 记录更新失败");
                    return;
                }
            }
        } catch (Exception e) {
            failureNum++;
            String msg = "<br/>" + failureNum + "、注视轨迹序列 记录导入失败：";
            failureMsg.append(msg).append(e.getMessage());
            log.error(msg, e);
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {

    }

    @Override
    public ExcelResult<TrackSequenceImportVo> getExcelResult() {
        return new ExcelResult<>() {

            @Override
            public String getAnalysis() {
                if (failureNum > 0) {
                    failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据没有成功导入，错误如下：");
                    throw new ServiceException(failureMsg.toString());
                } else {
                    successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
                }
                return successMsg.toString();
            }

            @Override
            public List<TrackSequenceImportVo> getList() {
                return null;
            }

            @Override
            public List<String> getErrorList() {
                return null;
            }
        };
    }
}
